class ArbreGenerique<U extends Comparable<U>> {
	NoeudGenerique<U> racine;

	ArbreGenerique(NoeudGenerique<U> n) {
		racine = n;
	}

	ArbreGenerique() {
		this(null);
	}

	int nbNoeuds() {
		return OperationsGeneriques.nbNoeuds(racine);
	}

	int hauteur() {
		return OperationsGeneriques.hauteur(racine);
	}

	void insertion(U element) {
		racine = OperationsGeneriques.insertion(racine, element);
	}

	void suppression(U element) {
		racine = OperationsGeneriques.suppression(racine, element);
	}

	@Override
	public String toString() {
		return OperationsGeneriques.toString(racine);
	}

	public String afficheSequence() {
		return OperationsGeneriques.afficheSequence(racine);
	}
}