class OperationsGeneriques {
	static <A> int nbNoeuds(NoeudGenerique<A> r) {
		if (r == null)
			return 0;
		else
			return 1 + nbNoeuds(r.fg) + nbNoeuds(r.fd);
	}

	static <B> int hauteur(NoeudGenerique<B> r) {
		if (r == null)
			return 0;
		else
			return 1 + Math.max(hauteur(r.fg), hauteur(r.fd));
	}

	static <C> String toStringRec(NoeudGenerique<C> r, int indent) {
		if (r == null)
			return "";
		else {
			String result;
			result = toStringRec(r.fd, indent + 1);
			for (int i = 0; i < indent; i++)
				result += "  ";
			result += r.et + "\n";
			result += toStringRec(r.fg, indent + 1);
			return result;
		}
	}

	static <D> String toString(NoeudGenerique<D> r) {
		return toStringRec(r, 0);
	}

	static <E> String afficheSequence(NoeudGenerique<E> r) {
		if (r == null)
			return "";
		else
			return afficheSequence(r.fg) + r.et + " " + afficheSequence(r.fd);
	}

	static <F extends Comparable<F>> boolean recherche(NoeudGenerique<F> r, F et) {
		if (r == null)
			return false;
		else {
			if (r.et == et)
				return true;
			if (r.et.compareTo(et) < 0)
				return recherche(r.fd, et);
			return recherche(r.fg, et);
		}
	}

	static <G extends Comparable<G>> NoeudGenerique<G> insertion(NoeudGenerique<G> r, G et) {
		if (r == null)
			return new NoeudGenerique<>(null, et, null);
		else {
			if (r.et.compareTo(et) < 0)
				r.fd = insertion(r.fd, et);
			else
				r.fg = insertion(r.fg, et);
			return r;
		}
	}

	static <H> H max(NoeudGenerique<H> r) {
		if (r.fd != null)
			return max(r.fd);
		else
			return r.et;
	}

	static <I extends Comparable<I>> NoeudGenerique<I> suppression(NoeudGenerique<I> r, I et) {
		if (r == null)
			return null;
		else {
			if (r.et == et) {
				if ((r.fg == null) && (r.fd == null))
					return null;
				if (r.fg == null)
					return r.fd;
				if (r.fd == null)
					return r.fg;
				r.et = max(r.fg);
				r.fg = suppression(r.fg, r.et);
				return r;
			}
			if (r.et.compareTo(et) < 0)
				r.fd = suppression(r.fd, et);
			else
				r.fg = suppression(r.fg, et);
			return r;
		}
	}
}
